

#ifndef VECTOR_H
#define VECTOR_H
#include <exception>

class DivisionByZero 
	: public std::exception
{
};

class Vector
{
	public:
	Vector(float a, float b, float c) 
		:	x(a), y(b), z(c)
	{}

	Vector(float v)
		throw(DivisionByZero)
		:	x(v), y(v), z(v)
	{
		if (x == 0.0)	throw DivisionByZero();
	}

	void set(float v)
	{
		x = y = z = v;
	}

	void normalize() 
		throw(DivisionByZero)
	{
		float len = sqrt(x * x + y * y + z * z);
		if (len == 0.0) throw DivisionByZero();

		x /= len;
		y /= len;
		z /= len;
	}

	virtual ~Vector() 
		throw()
	{}
	
	float x, y, z;
};

#endif // VECTOR_H
